import { createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import classnames from 'classnames';
import { defineComponent } from 'vue';
export default defineComponent({
  install: null,
  name: 'MActivityIndicator',
  props: {
    prefixCls: {
      type: String,
      default: 'am-activity-indicator'
    },
    className: {
      type: String
    },
    animating: {
      type: Boolean,
      default: true
    },
    toast: {
      type: Boolean,
      default: false
    },
    size: {
      default: 'small'
    },
    text: {
      type: String
    }
  },
  render: function render() {
    var _this$$props = this.$props,
      prefixCls = _this$$props.prefixCls,
      className = _this$$props.className,
      animating = _this$$props.animating,
      toast = _this$$props.toast,
      size = _this$$props.size,
      text = _this$$props.text;
    var wrapClass = classnames(prefixCls, className, _defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-lg"), size === 'large'), "".concat(prefixCls, "-sm"), size === 'small'), "".concat(prefixCls, "-toast"), toast));
    var spinnerClass = classnames("".concat(prefixCls, "-spinner"), _defineProperty({}, "".concat(prefixCls, "-spinner-lg"), toast || size === 'large'));
    if (animating) {
      if (toast) {
        return _createVNode("div", {
          "class": wrapClass
        }, [text ? _createVNode("div", {
          "class": "".concat(prefixCls, "-content")
        }, [_createVNode("span", {
          "class": spinnerClass,
          "aria-hidden": "true"
        }, null), _createVNode("span", {
          "class": "".concat(prefixCls, "-toast")
        }, [text])]) : _createVNode("div", {
          "class": "".concat(prefixCls, "-content")
        }, [_createVNode("span", {
          "class": spinnerClass,
          "aria-label": "Loading"
        }, null)])]);
      } else {
        return text ? _createVNode("div", {
          "class": wrapClass
        }, [_createVNode("span", {
          "class": spinnerClass,
          "aria-hidden": "true"
        }, null), _createVNode("span", {
          "class": "".concat(prefixCls, "-tip")
        }, [text])]) : _createVNode("div", {
          "class": wrapClass
        }, [_createVNode("span", {
          "class": spinnerClass,
          "aria-label": "loading"
        }, null)]);
      }
    } else {
      return null;
    }
  }
});