import { createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import classnames from 'classnames';
import { defineComponent } from 'vue';
export default defineComponent({
  name: 'MBadge',
  props: {
    prefixCls: {
      type: String,
      default: 'am-badge'
    },
    hot: {
      type: Boolean,
      default: false
    },
    size: {
      type: String,
      default: 'small'
    },
    overflowCount: {
      type: Number,
      default: 99
    },
    corner: {
      type: Boolean,
      default: false
    },
    dot: {
      type: Boolean,
      default: false
    },
    text: {
      type: [String, Number]
    },
    textStyle: {
      type: Object
    }
  },
  render: function render() {
    var _this$$slots$default, _this$$slots, _this$$slots$default2, _this$$slots2;
    var text = this.$props.text;
    var _this$$props = this.$props,
      overflowCount = _this$$props.overflowCount,
      prefixCls = _this$$props.prefixCls,
      size = _this$$props.size,
      dot = _this$$props.dot,
      corner = _this$$props.corner,
      hot = _this$$props.hot;
    text = typeof text === 'number' && text > overflowCount ? "".concat(overflowCount, "+") : text;
    // dot mode don't need text
    if (dot) {
      text = '';
    }
    var scrollNumberCls = classnames(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-dot"), dot), "".concat(prefixCls, "-dot-large"), dot && size === 'large'), "".concat(prefixCls, "-text"), !dot && !corner), "".concat(prefixCls, "-corner"), corner), "".concat(prefixCls, "-corner-large"), corner && size === 'large'));
    var badgeCls = classnames(prefixCls, _defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-not-a-wrapper"), !((_this$$slots$default = (_this$$slots = this.$slots).default) !== null && _this$$slots$default !== void 0 && _this$$slots$default.call(_this$$slots))), "".concat(prefixCls, "-corner-wrapper"), corner), "".concat(prefixCls, "-hot"), hot), "".concat(prefixCls, "-corner-wrapper-large"), corner && size === 'large'));
    return _createVNode("span", {
      "class": badgeCls
    }, [(_this$$slots$default2 = (_this$$slots2 = this.$slots).default) === null || _this$$slots$default2 === void 0 ? void 0 : _this$$slots$default2.call(_this$$slots2), (text || dot) && _createVNode("sup", {
      "class": scrollNumberCls,
      "style": this.textStyle
    }, [text])]);
  }
});