import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import { createVNode as _createVNode } from "vue";
import classnames from 'classnames';
import { defineComponent } from 'vue';
import Icon from '../../icon';
import { filterHTMLAttrs } from '../../utils/dom';
import TouchFeedback from '../../vmc-feedback';
var rxTwoCNChar = /^[\u4e00-\u9fa5]{2}$/;
var isTwoCNChar = rxTwoCNChar.test.bind(rxTwoCNChar);
function isString(str) {
  return typeof str === 'string';
}
export default defineComponent({
  install: null,
  inheritAttrs: false,
  name: 'MButton',
  props: {
    onClick: {},
    prefixCls: {
      type: String,
      default: 'am-button'
    },
    role: {
      type: String
    },
    inline: {
      type: Boolean,
      default: false
    },
    icon: {
      type: [String, Object, Function]
    },
    activeClassName: {
      type: String
    },
    activeStyle: {
      type: [Boolean, Object],
      default: function _default() {
        return {};
      }
    },
    type: {
      type: String
    },
    size: {
      type: String,
      default: 'large'
    },
    disabled: {
      type: Boolean,
      default: false
    },
    loading: {
      type: Boolean,
      default: false
    }
  },
  setup: function setup(props, _ref) {
    var emit = _ref.emit,
      slots = _ref.slots;
    var insertSpace = function insertSpace(child) {
      if (isString(child.text) && isTwoCNChar(child.text)) {
        return _createVNode("span", null, [child.text.split('').join(' ')]);
      }
      return child;
    };
    return {
      insertSpace: insertSpace
    };
  },
  render: function render() {
    var _this$$slots$default$,
      _this$$slots$default,
      _this$$slots,
      _this$$slots$default$2,
      _this = this;
    var _this$$props = this.$props,
      prefixCls = _this$$props.prefixCls,
      type = _this$$props.type,
      size = _this$$props.size,
      inline = _this$$props.inline,
      disabled = _this$$props.disabled,
      icon = _this$$props.icon,
      loading = _this$$props.loading,
      activeStyle = _this$$props.activeStyle,
      activeClassName = _this$$props.activeClassName;
    var iconType = loading ? 'loading' : icon;
    var wrapCls = classnames(prefixCls, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-primary"), type === 'primary'), "".concat(prefixCls, "-ghost"), type === 'ghost'), "".concat(prefixCls, "-warning"), type === 'warning'), "".concat(prefixCls, "-small"), size === 'small'), "".concat(prefixCls, "-inline"), inline), "".concat(prefixCls, "-disabled"), disabled), "".concat(prefixCls, "-loading"), loading), "".concat(prefixCls, "-icon"), !!iconType), this.$attrs.class);
    var kids = (_this$$slots$default$ = (_this$$slots$default = (_this$$slots = this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : (_this$$slots$default$2 = _this$$slots$default.call(_this$$slots)) === null || _this$$slots$default$2 === void 0 ? void 0 : _this$$slots$default$2.map(this.insertSpace)) !== null && _this$$slots$default$ !== void 0 ? _this$$slots$default$ : '';
    var iconEl = iconType ? _createVNode(Icon, {
      "type": iconType,
      "class": "".concat(prefixCls, "-icon"),
      "size": 'small' ? 'xxs' : 'md'
    }, null) : null;
    return _createVNode(TouchFeedback, {
      "activeClassName": activeClassName || (activeStyle ? "".concat(prefixCls, "-active") : undefined),
      "disabled": disabled,
      "activeStyle": activeStyle
    }, {
      default: function _default() {
        return [_createVNode("a", _objectSpread(_objectSpread({
          "role": "button"
        }, filterHTMLAttrs(_this.$attrs)), {}, {
          "class": wrapCls,
          "onClick": function onClick(e) {
            if (!_this.disabled) {
              _this.$emit('click', e);
            }
          },
          "aria-disabled": disabled
        }), [iconEl, kids])];
      }
    });
  }
});