import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { defineComponent } from 'vue';
import Icon from '../../icon';
import { getComponentLocale } from '../../utils/getLocale';
import { Calendar as VMCalendar } from '../../vmc-calendar';
import CalendarProps from '../../vmc-calendar/calendar-props';
import defaultLocale from './locale/zh_CN';
import { useLocalValue } from "../../utils/value";
export default defineComponent({
  install: null,
  Item: null,
  name: 'MCalendar',
  props: _objectSpread(_objectSpread({}, CalendarProps), {}, {
    prefixCls: {
      type: String,
      default: 'am-calendar'
    },
    timePickerPrefixCls: {
      type: String,
      default: 'am-picker'
    },
    timePickerPickerPrefixCls: {
      type: String,
      default: 'am-picker-col'
    }
  }),
  emits: ['update:value', 'confirm', 'cancel', 'close', 'clear', 'select-has-disable-date', 'change'],
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var _useLocalValue = useLocalValue(props, emit, {
        autoEmit: false,
        prop: 'value'
      }),
      localValue = _useLocalValue.localValue;
    var _useLocalValue2 = useLocalValue(props, emit, 'open'),
      localOpen = _useLocalValue2.localValue;
    var onConfirm = function onConfirm() {
      for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
        args[_key] = arguments[_key];
      }
      emit.apply(void 0, ['confirm'].concat(args));
      emit('update:value', localValue.value);
      onClose();
    };
    var onClear = function onClear(e) {
      localValue.value = undefined;
      emit('update:value', undefined);
      localOpen.value = false;
      emit('clear', e);
    };
    var onClose = function onClose() {
      localOpen.value = false;
      for (var _len2 = arguments.length, args = new Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
        args[_key2] = arguments[_key2];
      }
      emit.apply(void 0, ['close'].concat(args));
    };
    return {
      onClose: onClose,
      onConfirm: onConfirm,
      onClear: onClear,
      localValue: localValue,
      localOpen: localOpen
    };
  },
  render: function render() {
    var _this = this;
    var locale = getComponentLocale(this.$props, {}, 'Calendar', function () {
      return defaultLocale;
    });
    var Header = VMCalendar.DefaultHeader;
    return _createVNode(VMCalendar, _objectSpread(_objectSpread({}, this.$props), {}, {
      'value': _this.localValue,
      "onUpdate:value": function onUpdateValue($event) {
        return _this.localValue = $event;
      },
      "locale": locale,
      "renderHeader": function renderHeader(headerProps) {
        return _createVNode(Header, _objectSpread(_objectSpread({}, headerProps), {}, {
          "closeIcon": _createVNode(Icon, {
            "type": "cross"
          }, null)
        }), null);
      },
      "onCancel": function onCancel() {
        for (var _len3 = arguments.length, args = new Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
          args[_key3] = arguments[_key3];
        }
        _this.$emit.apply(_this, ['cancel'].concat(args));
      },
      "onClose": this.onClose,
      "onConfirm": this.onConfirm,
      "onClear": this.onClear,
      "onSelectHasDisableDate": function onSelectHasDisableDate() {
        for (var _len4 = arguments.length, args = new Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
          args[_key4] = arguments[_key4];
        }
        _this.$emit.apply(_this, ['select-has-disable-date'].concat(args));
      },
      "open": this.localOpen
    }), null);
  }
});