import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { defineComponent, reactive } from 'vue';
import defaultLocale from './locale/zh_CN';
import Icon from '../../icon';
import { getComponentLocale } from '../../utils/getLocale';
import { CalendarView as VMCalendar } from '../../vmc-calendar';
import CalendarProps from '../../vmc-calendar/calendar-props';
var endOfMonth = function endOfMonth() {
  var now = new Date();
  return new Date(new Date(now.getFullYear(), now.getMonth() + 1, 1).getTime() - 24 * 3600 * 1000);
};
var beginOfMonth = function beginOfMonth() {
  var now = new Date();
  return new Date(now.getFullYear(), now.getMonth(), 1);
};
export default defineComponent({
  name: 'MCalendarView',
  props: _objectSpread(_objectSpread({}, CalendarProps), {}, {
    prefixCls: {
      type: String,
      default: 'am-calendar'
    },
    timePickerPrefixCls: {
      type: String,
      default: 'am-picker'
    },
    timePickerPickerPrefixCls: {
      type: String,
      default: 'am-picker-col'
    }
  }),
  setup: function setup(props) {
    var state = reactive({
      open: props.open
    });
    return {
      state: state
    };
  },
  render: function render() {
    var _this = this;
    var locale = getComponentLocale(this.$props, {}, 'Calendar', function () {
      return defaultLocale;
    });
    var Header = VMCalendar.DefaultHeader;
    return (// @ts-ignore
      _createVNode(VMCalendar, _objectSpread(_objectSpread({
        "class": this.prefixCls + '-view',
        "locale": locale,
        "renderHeader": function renderHeader(headerProps) {
          return _createVNode(Header, _objectSpread(_objectSpread({}, headerProps), {}, {
            "closeIcon": _createVNode(Icon, {
              "type": "cross"
            }, null)
          }), null);
        },
        "onSelectHasDisableDate": function onSelectHasDisableDate() {
          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }
          _this.$emit.apply(_this, ['select-has-disable-date'].concat(args));
        }
      }, _objectSpread(_objectSpread({}, this.$props), {}, {
        type: 'one',
        displayMode: true,
        minDate: this.minDate || beginOfMonth(),
        maxDate: this.maxDate || endOfMonth()
      })), {}, {
        "open": this.state.open
      }), null)
    );
  }
});