import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { createVNode as _createVNode } from "vue";
import _objectDestructuringEmpty from "@babel/runtime/helpers/esm/objectDestructuringEmpty";
import _extends from "@babel/runtime/helpers/esm/extends";
import classnames from 'classnames';
import { defineComponent, reactive, watch } from 'vue';
import getDataAttr from '../../utils/get-data-attr';
import Checkbox from './checkbox';
export default defineComponent({
  name: 'MAgreeItem',
  props: {
    prefixCls: {
      type: String,
      default: 'am-checkbox'
    },
    name: {
      type: String
    },
    wrapLabel: {
      type: Boolean,
      default: true
    },
    defaultValue: {
      type: Boolean,
      default: false
    },
    value: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean,
      default: false
    }
  },
  emits: ['update:value', 'change'],
  setup: function setup(props, _ref) {
    var _props$value;
    var emit = _ref.emit;
    var state = reactive({
      value: (_props$value = props.value) !== null && _props$value !== void 0 ? _props$value : props.defaultValue
    });
    watch(function () {
      return state.value;
    }, function (value) {
      emit('update:value', value);
    });
    watch(function () {
      return props.value;
    }, function (value) {
      state.value = value;
    });
    return {
      state: state
    };
  },
  render: function render() {
    var _this = this;
    var restProps = _extends({}, (_objectDestructuringEmpty(this.$props), this.$props));
    var prefixCls = restProps.prefixCls;
    var wrapCls = classnames("".concat(prefixCls, "-agree"));
    return _createVNode("div", _objectSpread(_objectSpread({}, getDataAttr(restProps)), {}, {
      "class": wrapCls
    }), [_createVNode(Checkbox, _objectSpread(_objectSpread({}, restProps), {}, {
      'value': _this.state.value,
      "onUpdate:value": function onUpdateValue($event) {
        return _this.state.value = $event;
      },
      "class": "".concat(prefixCls, "-agree-label")
    }), {
      default: function _default() {
        return [_this.$slots.default()];
      }
    })]);
  }
});