import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["listPrefixCls", "disabled", "readOnly", "checkboxProps"];
import classnames from 'classnames';
import { defineComponent } from 'vue';
import List from '../../list';
import Checkbox from './checkbox';
import { usePureInput } from "../../mixins/pure-input-component";
export default defineComponent({
  name: 'MCheckboxItem',
  props: {
    thumbStyle: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    listPrefixCls: {
      type: String,
      default: 'am-list-item'
    },
    prefixCls: {
      type: String,
      default: 'am-checkbox'
    },
    name: {
      type: String
    },
    wrapLabel: {
      type: Boolean,
      default: false
    },
    checkboxProps: {
      type: Object,
      default: function _default() {
        return {};
      }
    },
    extra: {
      type: String
    },
    disabled: {
      type: Boolean,
      default: false
    },
    readOnly: {
      type: Boolean
    },
    value: {
      type: Boolean,
      default: false
    }
  },
  emits: ['change', 'update:value'],
  setup: function setup(props, _ref) {
    var emit = _ref.emit,
      attrs = _ref.attrs,
      slots = _ref.slots;
    var _usePureInput = usePureInput(props, {
        emit: emit,
        attrs: attrs,
        slots: slots
      }),
      stateValue = _usePureInput.stateValue,
      setStateValue = _usePureInput.setStateValue;
    var onChange = function onChange() {
      // do nothing
    };
    var onClick = function onClick() {
      if (!props.disabled && !props.readOnly) {
        setStateValue(!stateValue.value);
      }
    };
    return {
      stateValue: stateValue,
      onChange: onChange,
      onClick: onClick
    };
  },
  render: function render() {
    var _this = this;
    var _this$$props = this.$props,
      listPrefixCls = _this$$props.listPrefixCls,
      disabled = _this$$props.disabled,
      readOnly = _this$$props.readOnly,
      checkboxProps = _this$$props.checkboxProps,
      restProps = _objectWithoutProperties(_this$$props, _excluded);
    var prefixCls = restProps.prefixCls;
    var wrapCls = classnames("".concat(prefixCls, "-item"), _defineProperty(_defineProperty({}, "".concat(prefixCls, "-item-disabled"), disabled === true), "".concat(prefixCls, "-item-readonly"), readOnly === true));
    var extraProps = {};
    ['name', 'defaultChecked', 'checked', 'onChange', 'disabled'].forEach(function (i) {
      if (i in _this.$props) {
        extraProps[i] = _this.$props[i];
      }
    });
    var thumb = _createVNode(Checkbox, _objectSpread(_objectSpread({}, _objectSpread(_objectSpread(_objectSpread({}, checkboxProps), extraProps), {}, {
      value: this.stateValue
    })), {}, {
      "style": this.thumbStyle,
      "onChange": this.onChange
    }), null);
    return _createVNode(List.Item, _objectSpread(_objectSpread({}, restProps), {}, {
      "touchFeedback": !this.disabled,
      "onClick": this.onClick,
      "prefixCls": listPrefixCls,
      "class": wrapCls,
      "thumb": thumb
    }), {
      default: function _default() {
        return [_this.$slots.default()];
      }
    });
  }
});