import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { createVNode as _createVNode } from "vue";
import RcCheckbox from 'ant-design-vue/es/vc-checkbox/Checkbox';
import classnames from 'classnames';
import { defineComponent } from 'vue';
import { usePureInput } from '../../mixins/pure-input-component';
export default defineComponent({
  name: 'MCheckbox',
  props: {
    prefixCls: {
      type: String,
      default: 'am-checkbox'
    },
    name: {
      type: String
    },
    wrapLabel: {
      type: Boolean,
      default: true
    },
    disabled: {
      type: Boolean,
      default: false
    },
    value: {
      type: Boolean,
      default: false
    }
  },
  emits: ['update:value', 'click', 'change'],
  setup: function setup(props, _ref) {
    var emit = _ref.emit,
      attrs = _ref.attrs,
      slots = _ref.slots;
    var _usePureInput = usePureInput(props, {
        emit: emit,
        attrs: attrs,
        slots: slots
      }),
      stateValue = _usePureInput.stateValue,
      setStateValue = _usePureInput.setStateValue;
    var onClick = function onClick(e) {
      e.stopPropagation();
      emit('click', e);
      setStateValue(!stateValue.value);
    };
    return {
      onClick: onClick
    };
  },
  render: function render() {
    var _this$$slots$default,
      _this$$slots,
      _this = this;
    var prefixCls = this.$props.prefixCls;
    var wrapCls = classnames("".concat(prefixCls, "-wrapper"));
    var mark = _createVNode("label", {
      "class": wrapCls
    }, [_createVNode(RcCheckbox, _objectSpread({
      "onClick": this.onClick,
      "checked": this.value
    }, this.$props), null), (_this$$slots$default = (_this$$slots = this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)]);
    if (this.wrapLabel) {
      return mark;
    }
    return _createVNode(RcCheckbox, _objectSpread({
      "onClick": this.onClick,
      "checked": this.value
    }, this.$props), {
      default: function _default() {
        return [_this.$slots.default()];
      }
    });
  }
});