import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import classNames from 'classnames';
import { defineComponent, inject, ref } from 'vue';
import List from '../../list';
import { useBaseInputComponent } from '../../mixins/base-input-component';
import { creatFormComponentProps } from '../../mixins/form-component';
import DatePicker from './index';
export default defineComponent({
  name: 'MDatePickerItem',
  inheritAttrs: false,
  props: _objectSpread(_objectSpread({}, creatFormComponentProps()), {}, {
    title: {
      type: [String, Object]
    }
  }),
  setup: function setup(props, _ref) {
    var emit = _ref.emit,
      slots = _ref.slots,
      attrs = _ref.attrs;
    var form = inject('list', undefined);
    var _useBaseInputComponen = useBaseInputComponent(props, {
        emit: emit,
        slots: slots,
        attrs: attrs
      }, form),
      stateValue = _useBaseInputComponen.stateValue,
      isDisabled = _useBaseInputComponen.isDisabled,
      cssStyle = _useBaseInputComponen.cssStyle,
      isReadonly = _useBaseInputComponen.isReadonly;
    var localOpen = ref(false);
    return {
      stateValue: stateValue,
      localOpen: localOpen,
      isDisabled: isDisabled,
      isReadonly: isReadonly,
      cssStyle: cssStyle
    };
  },
  render: function render() {
    var _this = this;
    return _createVNode(DatePicker, _objectSpread(_objectSpread({}, this.$attrs), {}, {
      "disabled": this.isDisabled,
      "editable": !this.isReadonly,
      'value': _this.stateValue,
      "onUpdate:value": function onUpdateValue($event) {
        return _this.stateValue = $event;
      },
      'open': _this.localOpen,
      "onUpdate:open": function onUpdateOpen($event) {
        return _this.localOpen = $event;
      }
    }), _objectSpread({
      default: function _default() {
        return [_createVNode(List.Item, {
          "title": _this.title,
          "touchFeedback": true,
          "onClick": function onClick() {
            _this.localOpen = true;
          },
          "style": _this.cssStyle,
          "class": classNames('am-date-picker-item', _this.$attrs.class),
          "required": _this.required,
          "disabled": _this.isDisabled,
          "error": _this.error,
          "errorDisplayType": _this.errorDisplayType,
          "errorMessage": _this.errorMessage,
          "arrow": "horizontal"
        }, null)];
      }
    }, this.$slots));
  }
});