function formatIt(date, form) {
  var pad = function pad(n) {
    return n < 10 ? "0".concat(n) : n;
  };
  var dateStr = "".concat(date.getFullYear(), "-").concat(pad(date.getMonth() + 1), "-").concat(pad(date.getDate()));
  var timeStr = "".concat(pad(date.getHours()), ":").concat(pad(date.getMinutes()));
  if (form === 'YYYY') {
    return date.getFullYear() + '';
  }
  if (form === 'YYYY-MM-DD') {
    return dateStr;
  }
  if (form === 'YYYY-MM') {
    return dateStr.substring(0, 7);
  }
  if (form === 'HH:mm') {
    return timeStr;
  }
  return "".concat(dateStr, " ").concat(timeStr);
}
export function formatFn(value, format, mode) {
  var formatsEnum = {
    date: 'YYYY-MM-DD',
    time: 'HH:mm',
    datetime: 'YYYY-MM-DD HH:mm',
    year: 'YYYY',
    month: 'YYYY-MM'
  };
  if (typeof format === 'string') {
    if (typeof value === 'number' || typeof value === 'string') {
      return formatIt(new Date(value), format);
    } else {
      return formatIt(value, format);
    }
  } else if (typeof format === 'function') {
    return format(value);
  }
  if (typeof value === 'number' || typeof value === 'string') {
    return formatIt(new Date(value), formatsEnum[mode]);
  } else {
    return formatIt(value, formatsEnum[mode]);
  }
}