import { createVNode as _createVNode } from "vue";
import classNames from 'classnames';
import { defineComponent } from 'vue';
import EmptyIcon from '../../assets/empty-icon.svg';
import { withNativeProps } from '../../utils/native-props';
var classPrefix = "adm-empty";
var defaultProps = {
  image: EmptyIcon
};
export default defineComponent({
  name: 'MEmpty',
  props: {
    image: {
      type: [Object, String],
      default: function _default() {
        return EmptyIcon;
      }
    },
    imageStyle: {
      type: Object
    },
    description: {
      type: [Object, String]
    }
  },
  render: function render() {
    var imageNode = typeof this.image === 'string' ? _createVNode("img", {
      "class": "".concat(classPrefix, "-image"),
      "style": this.imageStyle,
      "src": this.image,
      "alt": "empty"
    }, null) : this.image;
    return withNativeProps(this.$props, _createVNode("div", {
      "class": classPrefix
    }, [_createVNode("div", {
      "class": "".concat(classPrefix, "-image-container")
    }, [imageNode]), this.description && _createVNode("div", {
      "class": classNames("".concat(classPrefix, "-description"))
    }, [this.description])]));
  }
});