import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["direction", "wrap", "justify", "align", "alignContent", "prefixCls"];
import { filterHTMLAttrs } from '../../utils/dom';
import classnames from 'classnames';
import { defineComponent } from 'vue';
export default defineComponent({
  inheritAttrs: false,
  Item: null,
  name: 'MFlex',
  props: {
    alignContent: {
      type: String
    },
    prefixCls: {
      type: String,
      default: 'am-flexbox'
    },
    role: {
      type: String
    },
    direction: {
      type: String
    },
    wrap: {
      type: String
    },
    justify: {
      type: String
    },
    align: {
      type: String,
      default: 'center'
    },
    disabled: {
      type: Boolean
    }
  },
  render: function render() {
    var _classnames, _this$$slots$default, _this$$slots;
    var _this$$props = this.$props,
      direction = _this$$props.direction,
      wrap = _this$$props.wrap,
      justify = _this$$props.justify,
      align = _this$$props.align,
      alignContent = _this$$props.alignContent,
      prefixCls = _this$$props.prefixCls,
      restProps = _objectWithoutProperties(_this$$props, _excluded);
    var wrapCls = classnames(prefixCls, (_classnames = {}, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_classnames, "".concat(prefixCls, "-dir-row"), direction === 'row'), "".concat(prefixCls, "-dir-row-reverse"), direction === 'row-reverse'), "".concat(prefixCls, "-dir-column"), direction === 'column'), "".concat(prefixCls, "-dir-column-reverse"), direction === 'column-reverse'), "".concat(prefixCls, "-nowrap"), wrap === 'nowrap'), "".concat(prefixCls, "-wrap"), wrap === 'wrap'), "".concat(prefixCls, "-wrap-reverse"), wrap === 'wrap-reverse'), "".concat(prefixCls, "-justify-start"), justify === 'start'), "".concat(prefixCls, "-justify-end"), justify === 'end'), "".concat(prefixCls, "-justify-center"), justify === 'center'), _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty(_classnames, "".concat(prefixCls, "-justify-between"), justify === 'between'), "".concat(prefixCls, "-justify-around"), justify === 'around'), "".concat(prefixCls, "-align-start"), align === 'start'), "".concat(prefixCls, "-align-center"), align === 'center'), "".concat(prefixCls, "-align-end"), align === 'end'), "".concat(prefixCls, "-align-baseline"), align === 'baseline'), "".concat(prefixCls, "-align-stretch"), align === 'stretch'), "".concat(prefixCls, "-align-content-start"), alignContent === 'start'), "".concat(prefixCls, "-align-content-end"), alignContent === 'end'), "".concat(prefixCls, "-align-content-center"), alignContent === 'center'), _defineProperty(_defineProperty(_defineProperty(_classnames, "".concat(prefixCls, "-align-content-between"), alignContent === 'between'), "".concat(prefixCls, "-align-content-around"), alignContent === 'around'), "".concat(prefixCls, "-align-content-stretch"), alignContent === 'stretch')), this.$attrs.class);
    var props = filterHTMLAttrs(_objectSpread(_objectSpread({}, restProps), this.$attrs));
    return _createVNode("div", _objectSpread(_objectSpread({}, props), {}, {
      "class": wrapCls
    }), [(_this$$slots$default = (_this$$slots = this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)]);
  }
});