import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { createVNode as _createVNode } from "vue";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["type", "prefixCls", "size"];
import classNames from 'classnames';
import { defineComponent, isVNode, onMounted } from 'vue';
import loadSprite from './load-sprite';
var Icon = defineComponent({
  inheritAttrs: false,
  name: 'MIcon',
  props: {
    prefixCls: {
      type: String,
      default: 'am-icon'
    },
    size: {
      type: [String, Number],
      default: 'md'
    },
    type: {
      type: [String, Object],
      required: true
    },
    color: String
  },
  setup: function setup() {
    onMounted(function () {
      loadSprite();
    });
    return {};
  },
  render: function render() {
    var _this$$attrs$style;
    var _this$$props = this.$props,
      type = _this$$props.type,
      prefixCls = _this$$props.prefixCls,
      size = _this$$props.size,
      restProps = _objectWithoutProperties(_this$$props, _excluded);
    var cls = classNames('am-icon', typeof type === 'string' ? "am-icon-".concat(type) : undefined, "am-icon-".concat(size), this.$attrs.class);
    var style = (_this$$attrs$style = this.$attrs.style) !== null && _this$$attrs$style !== void 0 ? _this$$attrs$style : {};
    if (this.color) {
      style.color = this.color;
    }
    if (typeof this.size === 'number') {
      style.width = this.size + 'px';
      style.height = this.size + 'px';
    }
    if (typeof type === 'function' || isVNode(type)) {
      var IconComponent = type;
      return _createVNode(IconComponent, {
        "class": cls,
        "style": style
      }, null);
    }
    return _createVNode("svg", _objectSpread(_objectSpread(_objectSpread({}, restProps), this.$attrs), {}, {
      class: cls,
      style: style
    }), [_createVNode("use", {
      "xlink:href": "#".concat(type)
    }, null)]);
  }
});
export default Icon;