import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import classNames from 'classnames';
import { defineComponent, ref, watch } from 'vue';
var Input = defineComponent({
  name: 'MInput',
  props: {
    value: {
      type: [String, Number]
    },
    disabled: Boolean,
    placeholder: String,
    readonly: Boolean,
    type: {
      type: String
    },
    textAlign: {
      type: String,
      default: 'left'
    }
  },
  setup: function setup(props, _ref) {
    var _props$value$toString, _props$value;
    var emit = _ref.emit;
    var currentValue = ref((_props$value$toString = (_props$value = props.value) === null || _props$value === void 0 ? void 0 : _props$value.toString()) !== null && _props$value$toString !== void 0 ? _props$value$toString : '');
    var inputRef = ref(null);
    var onInputBlur = function onInputBlur(e) {
      var value = e.target.value;
      emit('blur', value);
    };
    var onInputFocus = function onInputFocus(e) {
      emit('focus');
    };
    var focus = function focus() {
      if (inputRef.value) {
        inputRef.value.focus();
      }
    };
    watch(function () {
      return props.value;
    }, function (value) {
      currentValue.value = value === null || value === void 0 ? void 0 : value.toString();
    });
    return {
      currentValue: currentValue,
      inputRef: inputRef,
      onInputBlur: onInputBlur,
      focus: focus,
      onInputFocus: onInputFocus
    };
  },
  render: function render() {
    var _this = this;
    var currentValue = this.currentValue;
    var type = this.type === 'number' ? 'text' : this.type;
    var classes = classNames(this.$attrs.class, 'am-input-align-' + this.textAlign);
    var props = _objectSpread(_objectSpread(_objectSpread({}, this.$props), this.$attrs), {}, {
      class: classes,
      value: currentValue,
      type: type,
      ref: function ref(el) {
        _this.inputRef = el;
      },
      disabled: this.disabled,
      readonly: this.readonly,
      placeholder: this.placeholder,
      onBlur: function onBlur(e) {
        _this.onInputBlur(e);
      },
      onInput: function onInput(e) {
        _this.$emit('change', e);
      }
    });
    return _createVNode("input", props, null);
  }
});
export default Input;