import { defineComponent, createVNode as _createVNode } from 'vue';
import { withNativeProps } from '../utils/native-props';
var classPrefix = "adm-loading";
var colorRecord = {
  default: 'var(--adm-color-weak)',
  primary: 'var(--adm-color-primary)',
  white: 'var(--adm-color-white)'
};
export default defineComponent({
  name: 'MLoading',
  props: {
    color: {
      type: String,
      default: 'default'
    }
  },
  render: function render() {
    var _colorRecord$this$col;
    return withNativeProps(this.$props, _createVNode("div", {
      "style": {
        color: (_colorRecord$this$col = colorRecord[this.color]) !== null && _colorRecord$this$col !== void 0 ? _colorRecord$this$col : this.color
      },
      "class": classPrefix
    }, [_createVNode("svg", {
      "height": "1em",
      "viewBox": "0 0 100 40",
      "style": {
        verticalAlign: '-0.125em'
      }
    }, [_createVNode("g", {
      "stroke": "none",
      "stroke-width": "1",
      "fill": "none",
      "fill-rule": "evenodd"
    }, [_createVNode("g", {
      "transform": "translate(-100.000000, -71.000000)"
    }, [_createVNode("g", {
      "transform": "translate(95.000000, 71.000000)"
    }, [_createVNode("g", {
      "transform": "translate(5.000000, 0.000000)"
    }, [[0, 1, 2].map(function (i) {
      return _createVNode("rect", {
        "key": i,
        "fill": "currentColor",
        "x": 20 + i * 26,
        "y": "16",
        "width": "8",
        "height": "8",
        "rx": "2"
      }, [_createVNode("animate", {
        "attributeName": "y",
        "from": "16",
        "to": "16",
        "dur": "2s",
        "begin": "".concat(i * 0.2, "s"),
        "repeatCount": "indefinite",
        "values": "16; 6; 26; 16; 16",
        "keyTimes": "0; 0.1; 0.3; 0.4; 1",
        "id": "circ-anim"
      }, null)]);
    })])])])])])]));
  }
});