import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { useSimpleFormComponent } from './simple-form-component';
import { computed } from 'vue';
import { usePureInput } from './pure-input-component';
export var useBaseInputComponent = function useBaseInputComponent(props, _ref, form) {
  var emit = _ref.emit,
    attrs = _ref.attrs,
    slots = _ref.slots;
  var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {
    defaultValue: undefined,
    propName: 'value'
  };
  var _useSimpleFormCompone = useSimpleFormComponent(props, form),
    isReadonly = _useSimpleFormCompone.isReadonly,
    componentSize = _useSimpleFormCompone.componentSize,
    isDisabled = _useSimpleFormCompone.isDisabled;
  var _usePureInput = usePureInput(props, {
      emit: emit,
      attrs: attrs,
      slots: slots
    }, options),
    getSlotProps = _usePureInput.getSlotProps,
    setStateValue = _usePureInput.setStateValue,
    cssStyle = _usePureInput.cssStyle,
    listeners = _usePureInput.listeners,
    getDefaultSlot = _usePureInput.getDefaultSlot,
    getProps = _usePureInput.getProps,
    stateValue = _usePureInput.stateValue;
  return {
    isReadonly: isReadonly,
    componentSize: componentSize,
    isDisabled: isDisabled,
    getDefaultSlot: getDefaultSlot,
    slots: slots,
    stateValue: stateValue,
    setStateValue: setStateValue,
    listeners: listeners,
    cssStyle: cssStyle,
    props: computed(function () {
      return _objectSpread(_objectSpread(_objectSpread(_objectSpread(_objectSpread({}, getSlotProps()), attrs), props), getProps()), {}, {
        disabled: isDisabled,
        readOnly: isReadonly,
        open: stateValue
      });
    })
  };
};