import { defineComponent, getCurrentInstance, onMounted, ref, createVNode as _createVNode } from 'vue';
export default defineComponent({
  name: 'Portal',
  props: {
    getContainer: {
      type: Function,
      default: function _default() {
        var container = document.createElement('div');
        document.body.appendChild(container);
        return container;
      }
    }
  },
  setup: function setup(props, _ref) {
    var emit = _ref.emit,
      slots = _ref.slots;
    var container = ref(null);
    if (!container.value) {
      container.value = props.getContainer();
    }
    var instance = getCurrentInstance();
    onMounted(function () {
      container.value.appendChild(instance.vnode.el);
    });
    return {
      container: container
    };
  },
  render: function render() {
    var _this$$slots$default, _this$$slots;
    var children = (_this$$slots$default = (_this$$slots = this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots);
    if (children !== null && children !== void 0 && children.length) {
      return children[0];
    } else {
      return _createVNode("div", null, null);
    }
  }
});