import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
var _this = this;
import isEqual from 'lodash.isequal';
import { computed, getCurrentInstance, onBeforeUnmount, onMounted, ref, watch } from 'vue';
import { useEmitter } from './emitter';
export var usePureInput = function usePureInput(props, _ref) {
  var emit = _ref.emit,
    attrs = _ref.attrs,
    slots = _ref.slots;
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {
    defaultValue: undefined,
    propName: 'value'
  };
  var convertValue = ref(function (value) {
    return value;
  });
  var defaultValue = computed(function () {
    var convertedValue = convertValue.value(props[options.propName]);
    if (convertedValue !== null && convertedValue !== undefined) {
      return convertedValue;
    } else {
      var _options$defaultValue;
      return (_options$defaultValue = options === null || options === void 0 ? void 0 : options.defaultValue) !== null && _options$defaultValue !== void 0 ? _options$defaultValue : props.defaultValue;
    }
  });
  var stateValue = ref(defaultValue.value);
  var instance = getCurrentInstance();
  var _useEmitter = useEmitter(instance),
    dispatch = _useEmitter.dispatch;
  watch(function () {
    return stateValue.value;
  }, function (value) {
    var val = convertValueBack(value);
    if (!isEqual(props[options.propName], val)) {
      emit("update:".concat(options.propName), val);
    }
    emit('change', val);
    dispatch('DFormItem', 'd.form.change', [val]);
  });
  var setStateValue = function setStateValue(value) {
    var convertValue = convertValueBack(value);
    if (attrs["onUpdate:".concat(options.propName)]) {
      emit("update:".concat(options.propName), convertValue);
      emit('change', convertValue);
    } else {
      stateValue.value = convertValue;
    }
  };
  watch(function () {
    return props[options.propName];
  }, function (value) {
    var convertedValue = convertValue.value(value);
    if (!isEqual(stateValue.value, convertedValue)) {
      stateValue.value = convertedValue;
    }
  });
  var cssStyle = computed(function () {
    return props.style || attrs.style || {};
  });
  var listeners = computed(function () {
    var obj = _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, 'onUpdate:value', onInput), "onBlur", handleBlur), "onChange", handleChange), "onKeydown", handleKeydown), "onKeyup", handleKeyup);
    Object.keys(attrs).forEach(function (key) {
      if (key in obj) {
        obj[key] = attrs[key];
      }
    });
    return obj;
  });
  var convertValueBack = function convertValueBack(value) {
    return value;
  };
  var getInputComponent = function getInputComponent() {
    return {};
  };
  var getProps = function getProps() {
    return {};
  };
  var getSlotProps = function getSlotProps() {
    var props = {};
    Object.keys(slots).forEach(function (slotKey) {
      if (slotKey !== 'default') {
        props[slotKey] = slots[slotKey];
      }
    });
    return props;
  };
  var handleBlur = function handleBlur() {
    dispatch('DFormItem', 'd.form.blur', [stateValue.value]);
  };
  var handleChange = function handleChange(value) {
    if (value !== null && value !== undefined && value.toString() === '[object InputEvent]') {
      return;
    }
    var comp = getInputComponent();
    if (comp.model && comp.model.prop === 'value' && comp.model.event === 'change') {
      stateValue.value = value;
    }
  };
  var handleKeydown = function handleKeydown() {
    emit('keydown');
  };
  var handleKeyup = function handleKeyup() {
    emit('keyup');
  };
  var onInput = function onInput(value) {
    var val = value;
    if (value && value.toString() === '[object InputEvent]') {
      val = value.target.value;
    }
    emit("update:".concat(options.propName), val);
    if (props[options.propName] === undefined) {
      stateValue.value = val;
    }
  };
  var getDefaultSlot = function getDefaultSlot() {
    var _slots$default;
    return (_slots$default = slots.default) === null || _slots$default === void 0 ? void 0 : _slots$default.call(slots);
  };
  onMounted(function () {
    dispatch('DFormItem', 'd.form-item.setControl', [_this]);
  });
  onBeforeUnmount(function () {
    dispatch('DFormItem', 'd.form-item.setControl', [null]);
  });
  return {
    getInputComponent: getInputComponent,
    listeners: listeners,
    cssStyle: cssStyle,
    stateValue: stateValue,
    getDefaultSlot: getDefaultSlot,
    props: computed(function () {
      return _objectSpread(_objectSpread(_objectSpread(_objectSpread({}, getSlotProps()), attrs), props), getProps());
    }),
    setStateValue: setStateValue,
    slots: slots,
    getSlotProps: getSlotProps,
    getProps: getProps
  };
};
export var pureInputComponentProps = {
  block: Boolean,
  value: {},
  width: [String, Number]
};