import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import { createVNode as _createVNode } from "vue";
var _excluded = ["loading", "prefixCls", "wrapClassName", "transitionName", "maskTransitionName", "platform", "footer", "operation", "animated", "transparent", "popup", "animationType"];
import Dialog from 'ant-design-vue/es/vc-dialog';
import classnames from 'classnames';
import { defineComponent } from 'vue';
import Button from '../../button';
import Popup from '../../popup';
import TouchFeedback from '../../vmc-feedback';
export default defineComponent({
  alert: null,
  confirm: null,
  prompt: null,
  operation: null,
  install: null,
  name: 'MModal',
  props: {
    prefixCls: {
      default: 'am-modal'
    },
    transitionName: {
      type: String
    },
    maskTransitionName: {
      type: String
    },
    wrapClassName: {
      type: String
    },
    onText: {
      type: String
    },
    closeText: {
      type: String
    },
    wrapProps: {},
    loading: Boolean,
    platform: {
      type: String,
      default: 'ios'
    },
    bodyStyle: {
      type: Object
    },
    title: {
      type: [String, Object]
    },
    maskClosable: {
      type: Boolean,
      default: true
    },
    closable: {
      type: Boolean,
      default: false
    },
    footer: {
      type: Array,
      default: function _default() {
        return [];
      }
    },
    onClose: {
      type: Function
    },
    onOk: {
      type: Function
    },
    transparent: {
      type: Boolean,
      default: true
    },
    popup: {
      type: [Boolean, String],
      default: false
    },
    animated: {
      type: Boolean,
      default: true
    },
    animationType: {
      type: String,
      default: 'slide-down'
    },
    onAnimationEnd: {},
    animateAppear: {
      type: Boolean
    },
    operation: {
      type: Boolean,
      default: false
    },
    open: Boolean
  },
  setup: function setup() {
    var renderFooterButton = function renderFooterButton(button, prefixCls, i) {
      var buttonStyle = {};
      if (button.style) {
        buttonStyle = button.style;
        if (typeof buttonStyle === 'string') {
          var styleMap = {
            cancel: {},
            default: {},
            destructive: {
              color: 'red'
            }
          };
          buttonStyle = styleMap[buttonStyle] || {};
        }
      }
      var onClickFn = function onClickFn(e) {
        e.preventDefault();
        if (button.onPress) {
          button.onPress();
        }
      };
      return (// @ts-ignore
        _createVNode(TouchFeedback, {
          "activeClassName": "".concat(prefixCls, "-button-active"),
          "key": i
        }, {
          default: function _default() {
            return [_createVNode("a", {
              "class": "".concat(prefixCls, "-button"),
              "role": "button",
              "style": buttonStyle,
              "onClick": onClickFn
            }, [button.text || "Button"])];
          }
        })
      );
    };
    return {
      renderFooterButton: renderFooterButton
    };
  },
  render: function render() {
    var _this = this,
      _this$closeText,
      _this$onText;
    var _this$$props = this.$props,
      loading = _this$$props.loading,
      prefixCls = _this$$props.prefixCls,
      wrapClassName = _this$$props.wrapClassName,
      transitionName = _this$$props.transitionName,
      maskTransitionName = _this$$props.maskTransitionName,
      platform = _this$$props.platform,
      _this$$props$footer = _this$$props.footer,
      footer = _this$$props$footer === void 0 ? [] : _this$$props$footer,
      operation = _this$$props.operation,
      animated = _this$$props.animated,
      transparent = _this$$props.transparent,
      popup = _this$$props.popup,
      animationType = _this$$props.animationType,
      restProps = _objectWithoutProperties(_this$$props, _excluded);
    var buttonCount = footer.length + (this.onOk ? 1 : 0) + (this.onClose ? 1 : 0);
    var btnGroupClass = classnames("".concat(prefixCls, "-button-group-").concat(buttonCount > 1 && !operation ? 'h' : 'v'), "".concat(prefixCls, "-button-group-").concat(operation ? 'operation' : 'normal'));
    var footerDom = footer.length || this.onOk || this.onClose ? _createVNode("div", {
      "class": btnGroupClass,
      "role": "group"
    }, [footer.map(function (button, i) {
      return (
        // tslint:disable-next-line:jsx-no-multiline-js
        _this.renderFooterButton(button, prefixCls, i)
      );
    }), this.onClose ? _createVNode(Button, {
      "disabled": loading,
      "prefixCls": "am-modal-button",
      "onClick": function onClick(e) {
        _this.$emit('close', e);
      }
    }, {
      default: function _default() {
        return [(_this$closeText = _this.closeText) !== null && _this$closeText !== void 0 ? _this$closeText : '关闭'];
      }
    }) : undefined, this.onOk ? _createVNode(Button, {
      "loading": loading,
      "prefixCls": "am-modal-button",
      "onClick": function onClick(e) {
        _this.$emit('ok', e);
      }
    }, {
      default: function _default() {
        return [(_this$onText = _this.onText) !== null && _this$onText !== void 0 ? _this$onText : '确定'];
      }
    }) : undefined]) : null;
    var transName;
    var maskTransName;
    if (animated) {
      // tslint:disable-next-line:prefer-conditional-expression
      if (transparent) {
        transName = maskTransName = 'am-fade';
      } else {
        transName = maskTransName = 'am-slide-up';
      }
      if (popup) {
        transName = animationType === 'slide-up' ? 'am-slide-up' : 'am-slide-down';
        maskTransName = 'am-fade';
      }
    }
    var wrapCls = classnames(wrapClassName, _defineProperty({}, "".concat(prefixCls, "-wrap-popup"), popup));
    var cls = classnames(this.$attrs.class, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-transparent"), transparent), "".concat(prefixCls, "-popup"), popup), "".concat(prefixCls, "-operation"), operation), "".concat(prefixCls, "-popup-").concat(animationType), popup && animationType), "".concat(prefixCls, "-android"), platform === 'android'));
    if (this.popup) {
      var _this$$slots$default, _this$$slots;
      var placement = typeof this.popup === 'string' ? this.popup : 'bottom';
      return _createVNode(Popup, {
        "placement": placement,
        "showOk": false,
        "open": this.open,
        "title": this.title,
        "maskClosable": this.closable,
        "class": cls,
        "onOk": function onOk(e) {
          _this.$emit('ok', e);
        },
        "onCancel": this.onClose || function (e) {
          _this.$emit('close', e);
        }
      }, {
        default: function _default() {
          return [(_this$$slots$default = (_this$$slots = _this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)];
        }
      });
    }
    restProps['onUpdate:open'] = function (v) {
      _this.$emit('update:open', v);
    };
    return _createVNode(Dialog, _objectSpread(_objectSpread({}, restProps), {}, {
      "maskClosable": this.maskClosable,
      "visible": this.open,
      "prefixCls": prefixCls,
      "title": this.title,
      "class": cls,
      "onClose": this.onClose || function (e) {
        _this.$emit('update:visible', false);
        _this.$emit('close', e);
      },
      "wrapClassName": wrapCls,
      "transitionName": transitionName || transName,
      "maskTransitionName": maskTransitionName || maskTransName,
      "footer": footerDom
    }), {
      default: this.$slots.default
    });
  }
});