import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { Fragment as _Fragment, createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import { Popover } from 'ant-design-vue';
import classNames from 'classnames';
import { defineComponent, ref, watch } from 'vue';
export default defineComponent({
  name: 'MPopover',
  props: {
    /**
     * 是否显示气泡（v-model）
     */
    open: {
      type: Boolean,
      default: false
    },
    prefixCls: {
      type: String,
      default: 'am-popover'
    },
    /**
     * 是否显示遮罩
     */
    mask: {
      type: Boolean,
      default: true
    },
    /**
     * 是否允许点击遮罩层关闭
     */
    maskClosable: {
      type: Boolean,
      default: true
    },
    placement: {
      type: String
    },
    destroyOnHide: Boolean
  },
  item: null,
  install: null,
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var currentValue = ref(props.open);
    watch(function () {
      return props.open;
    }, function (value) {
      currentValue.value = value;
    });
    watch(function () {
      return currentValue.value;
    }, function (currentValue) {
      emit('update:open', currentValue);
      emit('change', currentValue);
    });
    return {
      currentValue: currentValue
    };
  },
  render: function render() {
    var _this = this;
    var maskClass = classNames("".concat(this.prefixCls, "-mask"), _defineProperty({}, "".concat(this.prefixCls, "-mask-hidden"), !this.currentValue));
    var slots = {
      content: this.$slots.content,
      default: function _default() {
        var _this$$slots$default, _this$$slots;
        return _createVNode(_Fragment, null, [(_this$$slots$default = (_this$$slots = _this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots), _this.mask ? _createVNode("div", {
          "onClick": function onClick(e) {
            if (!_this.maskClosable) {
              e.stopPropagation();
              e.preventDefault();
            }
          },
          "class": maskClass
        }, null) : null]);
      }
    };
    var popoverProps = _objectSpread(_objectSpread({}, this.$attrs), {}, {
      prefixCls: this.prefixCls,
      'v-model': [this.currentValue, 'open'],
      trigger: ['click'],
      destroyTooltipOnHide: this.destroyOnHide
    });
    return _createVNode(Popover, popoverProps, slots);
  }
});