import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import classnames from 'classnames';
import { defineComponent } from 'vue';
import TouchFeedback from '../../vmc-feedback';
export default defineComponent({
  name: 'MPopoverItem',
  props: {
    prefixCls: {
      type: String,
      default: 'am-popover'
    },
    /**
     * 图标
     */
    icon: {},
    /**
     * 是否禁用
     */
    disabled: {
      type: Boolean
    },
    firstItem: {
      type: String
    },
    activeStyle: {}
  },
  render: function render() {
    var _this = this,
      _this$$slots$default,
      _this$$slots;
    var _this$$props = this.$props,
      prefixCls = _this$$props.prefixCls,
      icon = _this$$props.icon,
      disabled = _this$$props.disabled,
      firstItem = _this$$props.firstItem,
      activeStyle = _this$$props.activeStyle;
    var cls = classnames("".concat(prefixCls, "-item"), _defineProperty({}, "".concat(prefixCls, "-item-disabled"), disabled));
    var activeClass = "".concat(prefixCls, "-item-active");
    if (firstItem) {
      activeClass += "".concat(prefixCls, "-item-fix-active-arrow");
    }
    return _createVNode(TouchFeedback, {
      "disabled": disabled,
      "activeClassName": activeClass,
      "activeStyle": activeStyle
    }, {
      default: function _default() {
        return [_createVNode("div", _objectSpread(_objectSpread({
          "class": cls
        }, _this.$attrs), {}, {
          "onClick": function onClick(e) {
            if (!_this.disabled) {
              _this.$emit('click', e);
            }
          }
        }), [_createVNode("div", {
          "class": "".concat(prefixCls, "-item-container")
        }, [icon ? // tslint:disable-next-line:jsx-no-multiline-js
        _createVNode("span", {
          "class": "".concat(prefixCls, "-item-icon"),
          "aria-hidden": "true"
        }, [icon]) : null, _createVNode("span", {
          "class": "".concat(prefixCls, "-item-content")
        }, [(_this$$slots$default = (_this$$slots = _this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)])])])];
      }
    });
  }
});