import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import classnames from 'classnames';
import { defineComponent, onMounted, ref } from 'vue';
export default defineComponent({
  install: null,
  name: 'MProgress',
  props: {
    prefixCls: {
      type: String,
      default: 'am-progress'
    },
    barStyle: {
      type: Object
    },
    percent: {
      type: Number,
      default: 0
    },
    position: {
      default: 'fixed'
    },
    unfilled: {
      type: Boolean,
      default: true
    },
    appearTransition: {
      type: Boolean,
      default: false
    }
  },
  setup: function setup(props) {
    var barRef = ref(null);
    var noAppearTransition = ref(true);
    onMounted(function () {
      if (props.appearTransition) {
        setTimeout(function () {
          if (barRef.value) {
            barRef.value.style.width = "".concat(props.percent, "%");
          }
        }, 10);
      }
    });
    return {
      noAppearTransition: noAppearTransition,
      setBarRef: function setBarRef(el) {
        barRef.value = el;
      }
    };
  },
  render: function render() {
    var prefixCls = this.prefixCls,
      position = this.position,
      unfilled = this.unfilled,
      _this$barStyle = this.barStyle,
      barStyle = _this$barStyle === void 0 ? {} : _this$barStyle;
    var percentStyle = {
      width: this.noAppearTransition || !this.appearTransition ? "".concat(this.percent, "%") : 0,
      height: 0
    };
    var wrapCls = classnames("".concat(prefixCls, "-outer"), _defineProperty(_defineProperty({}, "".concat(prefixCls, "-fixed-outer"), position === 'fixed'), "".concat(prefixCls, "-hide-outer"), !unfilled));
    return _createVNode("div", {
      "class": wrapCls,
      "role": "progressbar",
      "aria-valuemin": 0,
      "aria-valuemax": 100
    }, [_createVNode("div", {
      "ref": this.setBarRef,
      "class": "".concat(prefixCls, "-bar"),
      "style": _objectSpread(_objectSpread({}, barStyle), percentStyle)
    }, null)]);
  }
});