import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["listPrefixCls", "disabled", "readOnly", "radioProps"];
import classnames from 'classnames';
import Icon from '../../icon';
import { defineComponent } from 'vue';
import List from '../../list';
import { filterHTMLAttrs } from "../../utils/dom";
export default defineComponent({
  name: 'MRadioItem',
  inheritAttrs: false,
  props: {
    prefixCls: {
      default: 'am-radio'
    },
    listPrefixCls: {
      default: 'am-list-item'
    },
    radioProps: {
      default: function _default() {
        return {};
      }
    },
    disabled: {
      type: Boolean,
      default: false
    },
    readOnly: Boolean,
    value: {
      type: Boolean,
      default: false
    },
    iconType: {
      type: String,
      default: 'radio'
    }
  },
  emits: ['change', 'click'],
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var onClick = function onClick(e) {
      if (!props.disabled && !props.readOnly) {
        emit('click', e);
        emit('change', !props.value);
      }
    };
    return {
      onClick: onClick
    };
  },
  render: function render() {
    var _this = this,
      _this$$slots$default,
      _this$$slots;
    var _this$$props = this.$props,
      listPrefixCls = _this$$props.listPrefixCls,
      disabled = _this$$props.disabled,
      readOnly = _this$$props.readOnly,
      radioProps = _this$$props.radioProps,
      otherProps = _objectWithoutProperties(_this$$props, _excluded);
    var prefixCls = otherProps.prefixCls;
    var wrapCls = classnames("".concat(prefixCls, "-item"), _defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-item-disabled"), disabled === true), "".concat(prefixCls, "-item-selected"), this.value === true), "".concat(prefixCls, "-item-readonly"), readOnly === true), "".concat(prefixCls, "-item-icon-") + this.iconType, true));
    var extraProps = {};
    ['name', 'disabled'].forEach(function (i) {
      if (i in _this.$props) {
        extraProps[i] = _this.$props[i];
      }
    });
    return _createVNode(List.Item, _objectSpread(_objectSpread({}, _objectSpread(_objectSpread({}, otherProps), filterHTMLAttrs(this.$attrs))), {}, {
      "touchFeedback": !this.disabled && !this.value,
      "onClick": this.onClick,
      "prefixCls": listPrefixCls,
      "class": wrapCls
    }), {
      default: function _default() {
        return [_this.iconType === 'radio' ? _createVNode("div", {
          "class": prefixCls + '-icon'
        }, [_createVNode("svg", {
          "viewBox": "0 0 40 40"
        }, [_createVNode("path", {
          "d": "M20,9 C26.0752953,9 31,13.9247047 31,20 C31,26.0752953 26.0752953,31 20,31 C13.9247047,31 9,26.0752953 9,20 C9,13.9247047 13.9247047,9 20,9 Z",
          "fill": "currentColor"
        }, null)])]) : undefined, _createVNode("span", {
          "class": "".concat(prefixCls, "-item-label")
        }, [(_this$$slots$default = (_this$$slots = _this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)]), _this.value && _this.iconType && _createVNode(Icon, {
          "type": _this.iconType
        }, null)];
      }
    });
  }
});