import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import VcHandle from 'ant-design-vue/es/vc-slider/src/Handle';
import RcRange from 'ant-design-vue/es/vc-slider/src/Range';
import { defineComponent } from 'vue';
import { creatFormComponentProps, useFormComponent } from '../../mixins/form-component';
export default defineComponent({
  name: 'Range',
  props: _objectSpread(_objectSpread({}, creatFormComponentProps()), {}, {
    prefixCls: {
      type: String,
      default: 'am-slider'
    },
    handleStyle: Object,
    trackStyle: Object,
    railStyle: Object,
    onChange: Function,
    onAfterChange: Function,
    tipFormatter: {},
    pushable: {
      type: Boolean,
      default: false
    },
    min: {
      type: Number
    },
    max: {
      type: Number
    },
    step: {
      type: Number
    }
  }),
  setup: function setup(props, ctx) {
    var _useFormComponent = useFormComponent(props, ctx),
      currentValue = _useFormComponent.currentValue;
    var handle = function handle(info) {
      return _createVNode(VcHandle, info, null);
    };
    return {
      currentValue: currentValue,
      handle: handle
    };
  },
  render: function render() {
    var _this = this;
    var Range = RcRange;
    return _createVNode("div", {
      "class": "".concat(this.prefixCls, "-wrapper")
    }, [_createVNode(Range, _objectSpread(_objectSpread({}, this.$props), {}, {
      "handle": this.handle,
      "value": this.currentValue,
      "pushable": this.pushable,
      "onChange": function onChange(v) {
        _this.currentValue = v;
      }
    }), null)]);
  }
});