import { createVNode as _createVNode } from "vue";
import _extends from "@babel/runtime/helpers/esm/extends";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { defineComponent } from 'vue';
import List from '../../list';
import { creatFormComponentProps, useFormComponent } from '../../mixins/form-component';
import Range from './index';
var RangeItem = defineComponent({
  name: 'MRangeItem',
  props: _objectSpread(_objectSpread({}, creatFormComponentProps()), {}, {
    title: {
      type: [String, Object]
    }
  }),
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var _useFormComponent = useFormComponent(props, {
        emit: emit
      }),
      isDisabled = _useFormComponent.isDisabled,
      currentValue = _useFormComponent.currentValue;
    return {
      isDisabled: isDisabled,
      currentValue: currentValue
    };
  },
  render: function render() {
    var _this = this;
    return _createVNode(List.Item, {
      "multipleLine": true,
      "class": 'am-range-item',
      "error": this.error,
      "errorMessage": this.errorMessage,
      "errorDisplayType": this.errorDisplayType,
      "control": _createVNode(Range, _objectSpread(_objectSpread({}, _extends({}, this.$attrs, this.$props)), {}, {
        "style": {
          marginLeft: '8px'
        },
        "disabled": this.isDisabled,
        "value": this.currentValue,
        onChange: function onChange(v) {
          _this.currentValue = v;
        }
      }), null),
      "disabled": this.isDisabled
    }, {
      default: function _default() {
        return [_this.title];
      }
    });
  }
});
export default RangeItem;