import { createVNode as _createVNode } from "vue";
/* tslint:disable:jsx-no-multiline-js */
import classnames from 'classnames';
import { defineComponent } from 'vue';
import Button from '../../button';
export default defineComponent({
  install: null,
  name: 'MResult',
  props: {
    prefixCls: {
      type: String,
      default: 'am-result'
    },
    imgUrl: {
      type: String
    },
    img: {
      type: [String, Object]
    },
    title: {
      type: [String, Object]
    },
    message: {
      type: [String, Object]
    },
    buttonText: {
      type: String
    },
    buttonType: {
      type: String,
      default: ''
    }
  },
  render: function render() {
    var _this$$slots$img,
      _this$$slots,
      _this$$slots$title,
      _this$$slots2,
      _this$$slots$message,
      _this$$slots3,
      _this = this;
    var _this$$props = this.$props,
      prefixCls = _this$$props.prefixCls,
      imgUrl = _this$$props.imgUrl,
      buttonText = _this$$props.buttonText,
      buttonType = _this$$props.buttonType;
    var imgContent = null;
    var img = ((_this$$slots$img = (_this$$slots = this.$slots).img) === null || _this$$slots$img === void 0 ? void 0 : _this$$slots$img.call(_this$$slots)) || this.img;
    var title = ((_this$$slots$title = (_this$$slots2 = this.$slots).title) === null || _this$$slots$title === void 0 ? void 0 : _this$$slots$title.call(_this$$slots2)) || this.title;
    var message = ((_this$$slots$message = (_this$$slots3 = this.$slots).message) === null || _this$$slots$message === void 0 ? void 0 : _this$$slots$message.call(_this$$slots3)) || this.message;
    if (img) {
      imgContent = _createVNode("div", {
        "class": "".concat(prefixCls, "-pic")
      }, [img]);
    } else if (imgUrl) {
      imgContent = _createVNode("div", {
        "class": "".concat(prefixCls, "-pic"),
        "style": {
          backgroundImage: "url(".concat(imgUrl, ")")
        }
      }, null);
    }
    return _createVNode("div", {
      "class": classnames(prefixCls),
      "role": "alert"
    }, [imgContent, title ? _createVNode("div", {
      "class": "".concat(prefixCls, "-title")
    }, [title]) : null, message ? _createVNode("div", {
      "class": "".concat(prefixCls, "-message")
    }, [message]) : null, buttonText ? _createVNode("div", {
      "class": "".concat(prefixCls, "-button")
    }, [// @ts-ignore
    _createVNode(Button, {
      "type": buttonType,
      "onClick": function onClick() {
        _this.$emit('click');
      }
    }, {
      default: function _default() {
        return [buttonText];
      }
    })]) : null]);
  }
});