import _extends from "@babel/runtime/helpers/esm/extends";
import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import VcHandle from 'ant-design-vue/es/vc-slider/src/Handle';
import RcSlider from 'ant-design-vue/es/vc-slider/src/Slider';
import { defineComponent } from 'vue';
import { creatFormComponentProps, useFormComponent } from '../../mixins/form-component';
export default defineComponent({
  install: null,
  name: 'MSlider',
  props: _objectSpread(_objectSpread({}, creatFormComponentProps()), {}, {
    prefixCls: {
      type: String,
      default: 'am-slider'
    },
    marks: {},
    dots: {
      type: Boolean
    },
    included: {
      type: Boolean
    },
    handleStyle: {},
    trackStyle: {},
    railStyle: {},
    tipFormatter: {},
    min: {
      type: Number
    },
    max: {
      type: Number
    },
    step: {
      type: Number
    },
    handle: {},
    onChange: Function
  }),
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var _useFormComponent = useFormComponent(props, {
        emit: emit
      }),
      isDisabled = _useFormComponent.isDisabled,
      currentValue = _useFormComponent.currentValue;
    var handle = function handle(info) {
      return _createVNode(VcHandle, info, null);
    };
    return {
      isDisabled: isDisabled,
      handle: handle,
      currentValue: currentValue
    };
  },
  render: function render() {
    var _this = this;
    var props = _extends({}, this.$props, {
      disabled: this.isDisabled
    });
    var Slider = RcSlider;
    return _createVNode("div", {
      "class": "".concat(this.prefixCls, "-wrapper")
    }, [_createVNode(Slider, _objectSpread(_objectSpread({}, props), {}, {
      "value": this.currentValue,
      "handle": this.handle,
      "included": true,
      "onChange": function onChange(value) {
        _this.currentValue = value;
      }
    }), null)]);
  }
});