import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { defineComponent } from 'vue';
import List from '../../list';
import { creatFormComponentProps, useFormComponent } from '../../mixins/form-component';
import Slider from './index';
export default defineComponent({
  install: null,
  name: 'MSliderItem',
  props: _objectSpread(_objectSpread({}, creatFormComponentProps()), {}, {
    prefixCls: {
      type: String,
      default: 'am-slider'
    },
    marks: {},
    dots: {
      type: Boolean
    },
    included: {
      type: Boolean
    },
    maximumTrackStyle: {},
    minimumTrackStyle: {},
    handleStyle: {},
    trackStyle: {},
    railStyle: {},
    tipFormatter: {},
    min: {
      type: Number
    },
    max: {
      type: Number
    },
    step: {
      type: Number
    },
    handle: {},
    title: {
      type: [String, Object]
    }
  }),
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var _useFormComponent = useFormComponent(props, {
        emit: emit
      }),
      isDisabled = _useFormComponent.isDisabled,
      currentValue = _useFormComponent.currentValue;
    return {
      isDisabled: isDisabled,
      currentValue: currentValue
    };
  },
  render: function render() {
    var _this = this;
    return _createVNode(List.Item, {
      "multipleLine": true,
      "class": 'am-slider-item',
      "control": _createVNode(Slider, _objectSpread(_objectSpread({}, this.$props), {}, {
        "disabled": this.isDisabled,
        "style": {
          marginLeft: '8px'
        },
        "value": this.currentValue,
        "onChange": function onChange(v) {
          _this.currentValue = v;
        }
      }), null),
      "disabled": this.isDisabled
    }, {
      default: function _default() {
        return [_this.title];
      }
    });
  }
});