import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
var _excluded = ["showNumber", "value"];
import classnames from 'classnames';
import { defineComponent } from 'vue';
import Icon from '../../icon';
import RMCInputNumber from '../../vmc-input-number';
export default defineComponent({
  install: null,
  name: 'MStepper',
  props: {
    prefixCls: {
      type: String,
      default: 'am-stepper'
    },
    showNumber: {
      type: Boolean,
      default: true
    },
    min: {
      type: Number
    },
    max: {
      type: Number
    },
    step: {
      default: 1
    },
    readOnly: {
      type: Boolean,
      default: false
    },
    disabled: {
      type: Boolean
    },
    autoFocus: {
      type: Boolean
    },
    value: {
      type: [Number, String]
    },
    defaultValue: {
      type: Number
    },
    valueEditable: {
      type: Boolean,
      default: true
    },
    upStyle: {},
    downStyle: {},
    inputStyle: {},
    name: {
      type: String
    }
  },
  setup: function setup(props, _ref) {
    var emit = _ref.emit,
      slots = _ref.slots;
    var getCurrentValue = function getCurrentValue() {
      var value = props.value;
      var currentValue = null;
      if (typeof value === 'string') {
        if (value === '') {
          currentValue = null;
        } else {
          currentValue = parseInt(value);
        }
      } else {
        currentValue = value;
      }
      return currentValue;
    };
    return {
      getCurrentValue: getCurrentValue
    };
  },
  render: function render() {
    var _this$$props = this.$props,
      showNumber = _this$$props.showNumber,
      value = _this$$props.value,
      restProps = _objectWithoutProperties(_this$$props, _excluded);
    var stepperClass = classnames({
      showNumber: !!showNumber
    });
    var props = _objectSpread({}, restProps);
    props.upHandler = _createVNode(Icon, {
      "type": "plus",
      "size": "xxs"
    }, null);
    props.downHandler = _createVNode(Icon, {
      "type": "minus",
      "size": "xxs"
    }, null);
    return _createVNode(RMCInputNumber, _objectSpread(_objectSpread({}, _objectSpread(_objectSpread(_objectSpread({}, this.$attrs), props), {}, {
      value: this.getCurrentValue()
    })), {}, {
      "class": stepperClass
    }), null);
  }
});