import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import classNames from 'classnames';
import { defineComponent } from 'vue';
import { filterHTMLAttrs } from '../../utils/dom';
import { unwrapFragment } from '../../utils/vue';
export default defineComponent({
  name: 'MSteps',
  props: {
    icon: {
      type: [String, Object]
    },
    prefixCls: {
      type: String,
      default: 'am-steps'
    },
    iconPrefix: {
      type: String,
      default: 'ant'
    },
    direction: {
      type: String,
      default: 'vertical'
    },
    labelPlacement: {
      type: String,
      default: 'vertical'
    },
    status: {
      type: String,
      default: 'process'
    },
    size: {
      type: String,
      default: 'small'
    },
    progressDot: {
      type: Boolean,
      default: false
    },
    current: {
      type: Number,
      default: 0
    }
  },
  render: function render() {
    var _this$$slots$default, _this$$slots;
    var _this$$props = this.$props,
      prefixCls = _this$$props.prefixCls,
      direction = _this$$props.direction,
      labelPlacement = _this$$props.labelPlacement,
      iconPrefix = _this$$props.iconPrefix,
      status = _this$$props.status,
      size = _this$$props.size,
      current = _this$$props.current,
      progressDot = _this$$props.progressDot;
    var adjustedLabelPlacement = !!progressDot ? 'vertical' : labelPlacement;
    var classString = classNames(prefixCls, "".concat(prefixCls, "-").concat(direction), _defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-").concat(size), size), "".concat(prefixCls, "-label-").concat(adjustedLabelPlacement), direction === 'horizontal'), "".concat(prefixCls, "-dot"), !!progressDot));
    var children = unwrapFragment((_this$$slots$default = (_this$$slots = this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots));
    if (!children) {
      return _createVNode("div", _objectSpread(_objectSpread({}, filterHTMLAttrs(this.$attrs)), {}, {
        "class": classString
      }), null);
    }
    var content = children.map(function (child, index) {
      var _child$props, _child$props2, _child$props3, _child$props5;
      if (!child) {
        return null;
      }
      var childProps = {
        stepNumber: index + 1,
        prefixCls: prefixCls,
        iconPrefix: iconPrefix,
        icon: ((_child$props = child.props) === null || _child$props === void 0 ? void 0 : _child$props.icon) || '',
        wrapperStyle: {},
        progressDot: progressDot,
        status: ((_child$props2 = child.props) === null || _child$props2 === void 0 ? void 0 : _child$props2.status) || '',
        class: (_child$props3 = child.props) === null || _child$props3 === void 0 ? void 0 : _child$props3.class
      };
      var icon = childProps.icon;
      if (!icon) {
        var _child$props4;
        if (index < current) {
          // 对应 state: finish
          icon = 'check-circle-o';
        } else if (index > current) {
          // 对应 state: wait
          icon = 'ellipsis';
          childProps.class = classNames('ellipsis-item', childProps.class);
        }
        if (status === 'error' && index === current || ((_child$props4 = child.props) === null || _child$props4 === void 0 ? void 0 : _child$props4.status) === 'error') {
          icon = 'cross-circle-o';
        }
      }
      if (icon) {
        childProps.icon = icon;
      }
      // fix tail color
      if (status === 'error' && index === current - 1) {
        childProps.class = "".concat(prefixCls, "-next-error");
      }
      if (!((_child$props5 = child.props) !== null && _child$props5 !== void 0 && _child$props5.status)) {
        if (index === current) {
          childProps.status = status;
        } else if (index < current) {
          childProps.status = 'finish';
        } else {
          childProps.status = 'wait';
        }
      }
      if (child.props) {
        Object.keys(childProps).forEach(function (key) {
          child.props[key] = childProps[key];
        });
      } else {
        child.props = childProps;
      }
      return child;
    });
    return _createVNode("div", _objectSpread(_objectSpread({}, filterHTMLAttrs(this.$attrs)), {}, {
      "class": classString
    }), [content]);
  }
});