import { createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
var _excluded = ["listPrefixCls", "disabled", "switchProps"];
import classnames from 'classnames';
import { defineComponent, reactive, watch } from 'vue';
import List from '../../list';
import { creatFormComponentProps, useFormComponent } from '../../mixins/form-component';
import Switch from './switch';
var ListItem = List.Item;
var switchItem = defineComponent({
  name: 'MSwitchItem',
  props: _objectSpread(_objectSpread({}, creatFormComponentProps()), {}, {
    prefixCls: {
      default: 'am-switch'
    },
    listPrefixCls: {
      default: 'am-list-item'
    },
    switchProps: {
      default: function _default() {
        return {};
      }
    },
    title: {
      type: [String, Object]
    }
  }),
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var _useFormComponent = useFormComponent(props, {
        emit: emit
      }),
      isDisabled = _useFormComponent.isDisabled;
    var state = reactive({
      value: props.value
    });
    watch(function () {
      return props.value;
    }, function (value) {
      state.value = value;
    });
    watch(function () {
      return state.value;
    }, function (value, oldValue) {
      emit('update:value', value);
      if (value !== oldValue) {
        emit('change', value);
      }
    });
    var onClick = function onClick() {
      if (!props.disabled) {
        emit('click');
      }
    };
    return {
      state: state,
      onClick: onClick,
      isDisabled: isDisabled
    };
  },
  render: function render() {
    var _this = this,
      _this$$slots$default,
      _this$$slots;
    var _this$$props = this.$props,
      listPrefixCls = _this$$props.listPrefixCls,
      disabled = _this$$props.disabled,
      switchProps = _this$$props.switchProps,
      otherProps = _objectWithoutProperties(_this$$props, _excluded);
    var prefixCls = otherProps.prefixCls;
    var wrapCls = classnames("".concat(prefixCls, "-item"), _defineProperty({}, "".concat(prefixCls, "-item-disabled"), disabled === true));
    var extraProps = _objectSpread(_objectSpread(_objectSpread({}, this.$attrs), switchProps), {}, {
      disabled: this.isDisabled,
      value: this.state.value,
      'onUpdate:value': function onUpdateValue(value) {
        _this.state.value = value;
      },
      onClick: this.onClick
    });
    // @ts-ignore
    var extra = _createVNode(Switch, extraProps, null);
    var listItemProps = _objectSpread(_objectSpread({}, otherProps), {}, {
      disabled: this.isDisabled,
      prefixCls: listPrefixCls,
      class: wrapCls,
      control: extra
    });
    return _createVNode(ListItem, listItemProps, {
      default: function _default() {
        return [(_this$$slots$default = (_this$$slots = _this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)];
      }
    });
  }
});
export default switchItem;