import { createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectWithoutProperties from "@babel/runtime/helpers/esm/objectWithoutProperties";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
var _excluded = ["prefixCls", "name", "disabled", "platform", "color"];
import classnames from 'classnames';
import { defineComponent } from 'vue';
import { creatFormComponentProps, useFormComponent } from '../../mixins/form-component';
export default defineComponent({
  name: 'MSwitch',
  props: _objectSpread(_objectSpread({}, creatFormComponentProps()), {}, {
    color: {
      type: String
    },
    name: {
      type: String
    },
    prefixCls: {
      type: String,
      default: 'am-switch'
    },
    platform: {
      type: String,
      default: 'ios'
    }
  }),
  setup: function setup(props, ctx) {
    var _useFormComponent = useFormComponent(props, ctx),
      currentValue = _useFormComponent.currentValue;
    var onChange = function onChange(e) {
      currentValue.value = e.target.checked;
    };
    var onClick = function onClick(e) {
      var val;
      // tslint:disable-next-line:prefer-conditional-expression
      if (e && e.target && e.target.checked !== undefined) {
        val = e.target.checked;
      } else {
        val = props.value;
      }
      currentValue.value = val;
    };
    return {
      currentValue: currentValue,
      onChange: onChange,
      onClick: onClick
    };
  },
  render: function render() {
    var _this$$props = this.$props,
      prefixCls = _this$$props.prefixCls,
      name = _this$$props.name,
      disabled = _this$$props.disabled,
      platform = _this$$props.platform,
      color = _this$$props.color,
      restProps = _objectWithoutProperties(_this$$props, _excluded);
    var wrapCls = classnames(prefixCls, _defineProperty({}, "".concat(prefixCls, "-android"), platform === 'android'));
    var fackInputCls = classnames('checkbox', _defineProperty({}, "checkbox-disabled", disabled));
    var globalProps = Object.keys(_objectSpread(_objectSpread({}, restProps), this.$attrs)).reduce(function (prev, key) {
      if (key.substr(0, 5) === 'aria-' || key.substr(0, 5) === 'data-' || key === 'role') {
        prev[key] = restProps[key];
      }
      return prev;
    }, {});
    var style = {};
    if (color && this.currentValue) {
      style.backgroundColor = color;
    }
    return _createVNode("label", {
      "class": wrapCls
    }, [_createVNode("input", _objectSpread(_objectSpread({
      "type": "checkbox",
      "name": name,
      "class": "".concat(prefixCls, "-checkbox"),
      "disabled": disabled,
      "checked": this.currentValue,
      "onChange": this.onChange,
      "value": this.currentValue ? 'on' : 'off'
    }, !disabled ? {
      onClick: this.onClick
    } : {}), globalProps), null), _createVNode("div", _objectSpread({
      "class": fackInputCls,
      "style": style
    }, disabled ? {
      onClick: this.onClick
    } : {}), null)]);
  }
});