import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { computed, defineComponent, getCurrentInstance, inject } from 'vue';
import getDataAttr from '../../utils/get-data-attr';
import Tab from './tab';
export default defineComponent({
  inheritAttrs: false,
  name: 'MTabBarItem',
  props: {
    badge: {
      type: [String, Number]
    },
    selected: {
      type: Boolean,
      default: undefined
    },
    icon: {
      type: [String, Object]
    },
    selectedIcon: {
      type: [String, Object]
    },
    title: {
      type: [String, Object],
      default: ''
    },
    dot: {
      type: Boolean
    },
    prefixCls: {
      type: String,
      default: 'am-tab-bar'
    }
  },
  setup: function setup(props, _ref) {
    var emit = _ref.emit,
      slots = _ref.slots;
    var store = inject('tabBarStore');
    var tabBar = inject('tabBar');
    var instance = getCurrentInstance();
    var localSelected = computed(function () {
      return props.selected !== undefined ? props.selected : instance.vnode.key === store.currentTab;
    });
    return {
      tabBar: tabBar,
      localSelected: localSelected
    };
  },
  render: function render() {
    var _this$$slots,
      _this$$slots$default,
      _this = this;
    var _this$tabBar$props = this.tabBar.props,
      tintColor = _this$tabBar$props.tintColor,
      unselectedTintColor = _this$tabBar$props.unselectedTintColor;
    var icon = this.$slots.icon ? this.$slots.icon[0] : this.icon;
    var selectedIcon = this.$slots.selectedIcon ? this.$slots.selectedIcon : this.selectedIcon || icon;
    var props = _objectSpread(_objectSpread({}, this.$props), {}, {
      prefixCls: "".concat(this.prefixCls, "-tab"),
      tintColor: tintColor,
      unselectedTintColor: unselectedTintColor,
      icon: icon,
      selectedIcon: selectedIcon,
      selected: this.localSelected
    });
    return _createVNode(Tab, _objectSpread(_objectSpread({}, props), {}, {
      "dataAttrs": getDataAttr(this.$props)
    }), {
      default: function _default() {
        return [(_this$$slots = _this.$slots) === null || _this$$slots === void 0 ? void 0 : (_this$$slots$default = _this$$slots.default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)];
      }
    });
  }
});