import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import _objectDestructuringEmpty from "@babel/runtime/helpers/esm/objectDestructuringEmpty";
import classnames from 'classnames';
import { defineComponent } from 'vue';
import getDataAttr from '../../utils/get-data-attr';
import { usePureInput } from "../../mixins/pure-input-component";
var colorRecord = {
  default: '#000000d9',
  primary: '#1677ff',
  success: '#00b578',
  warning: '#ff8f1f',
  danger: '#ff3141'
};
export default defineComponent({
  name: 'MTag',
  props: {
    prefixCls: {
      type: String,
      default: 'am-tag'
    },
    color: {
      type: String,
      default: 'default'
    },
    fill: {
      type: String,
      default: 'solid'
    },
    round: Boolean,
    disabled: {
      type: Boolean,
      default: false
    },
    selected: {
      type: Boolean,
      default: false
    },
    small: {
      type: Boolean,
      default: false
    }
  },
  setup: function setup(props, _ref) {
    var emit = _ref.emit,
      attrs = _ref.attrs,
      slots = _ref.slots;
    _objectDestructuringEmpty(usePureInput(props, {
      emit: emit,
      attrs: attrs,
      slots: slots
    }));
    var onClick = function onClick() {
      var disabled = props.disabled;
      if (disabled) {
        return;
      }
      emit('select', !props.selected);
    };
    return {
      onClick: onClick
    };
  },
  render: function render() {
    var _colorRecord$this$col, _this$$slots$default, _this$$slots;
    var _this$$props = this.$props,
      prefixCls = _this$$props.prefixCls,
      disabled = _this$$props.disabled,
      small = _this$$props.small;
    var wrapCls = classnames(prefixCls, _defineProperty(_defineProperty(_defineProperty(_defineProperty(_defineProperty({}, "".concat(prefixCls, "-normal"), !disabled && !this.selected), "".concat(prefixCls, "-small"), small), "".concat(prefixCls, "-selected"), this.selected && !disabled), "".concat(prefixCls, "-disabled"), disabled), "".concat(prefixCls, "-round"), this.round));
    var color = (_colorRecord$this$col = colorRecord[this.color]) !== null && _colorRecord$this$col !== void 0 ? _colorRecord$this$col : this.color;
    var borderColor = this.color === 'default' ? '#d9d9d9' : color !== null && color !== void 0 ? color : '#ddd';
    var bgColor = this.fill === 'outline' || this.color === 'default' ? 'white' : color !== null && color !== void 0 ? color : 'white';
    var style = {
      '--border-color': borderColor,
      '--text-color': this.fill === 'outline' || this.color === 'default' ? color : 'white',
      '--background-color': bgColor
    };
    return _createVNode("div", _objectSpread(_objectSpread({}, getDataAttr(this.$props)), {}, {
      "style": style,
      "class": wrapCls,
      "onClick": this.onClick
    }), [_createVNode("div", {
      "class": "".concat(prefixCls, "-text")
    }, [(_this$$slots$default = (_this$$slots = this.$slots).default) === null || _this$$slots$default === void 0 ? void 0 : _this$$slots$default.call(_this$$slots)])]);
  }
});