import _extends from "@babel/runtime/helpers/esm/extends";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { camelize, resolvePropValue } from 'ant-design-vue/es/_util/util';
import isPlainObject from 'lodash-es/isPlainObject';
export var mergeProps = function mergeProps(props, defaultProps) {
  var newProps = _objectSpread({}, defaultProps);
  Object.keys(props).forEach(function (key) {
    if (props[key] !== undefined) {
      newProps[key] = props[key];
    }
  });
  return newProps;
};
export var getPropsData = function getPropsData(ins) {
  var vnode = ins.$ ? ins.$ : ins;
  var res = {};
  var originProps = vnode.props || {};
  var props = {};
  Object.keys(originProps).forEach(function (key) {
    props[camelize(key)] = originProps[key];
  });
  var options = isPlainObject(vnode.type) ? vnode.type.props : {};
  options && Object.keys(options).forEach(function (k) {
    var v = resolvePropValue(options, props, k, props[k]);
    if (k in props) {
      // 仅包含 props，不包含默认值
      res[k] = v;
    }
  });
  return _extends(_extends({}, props), res); // 合并事件、未声明属性等
};