import _typeof from "@babel/runtime/helpers/esm/typeof";
import { ref } from 'vue';
var useMemoizedFn = function useMemoizedFn(fn) {
  if (process.env.NODE_ENV === 'development') {
    if (typeof fn !== 'function') {
      console.error('useMemoizedFn expected parameter is a function, got ' + _typeof(fn));
    }
  }
  var fnRef = ref(fn);
  var memoizedFn = ref();
  if (!memoizedFn.value) {
    memoizedFn.value = function () {
      var args = [];
      for (var _i = 0; _i < arguments.length; _i++) {
        args[_i] = arguments[_i];
      } // eslint-disable-next-line @typescript-eslint/no-invalid-this

      return fnRef.value.apply(this, args);
    };
  }
  return memoizedFn.value;
};
export default useMemoizedFn;