import { ref, watchEffect } from 'vue';
var useUnmountedRef = function useUnmountedRef() {
  var unmountedRef = ref(false);
  watchEffect(function () {
    unmountedRef.value = false;
    return function () {
      unmountedRef.value = true;
    };
  });
  return unmountedRef;
};
export default useUnmountedRef;