import { createVNode as _createVNode } from "vue";
import _defineProperty from "@babel/runtime/helpers/esm/defineProperty";
import PropTypes from 'ant-design-vue/es/_util/vue-types';
import { getSlot } from 'ant-design-vue/es/_util/props-util';
import { defineComponent } from 'vue';
export default defineComponent({
  name: 'PanelContent',
  props: {
    prefixCls: PropTypes.string,
    isActive: PropTypes.looseBool,
    destroyInactivePanel: PropTypes.looseBool,
    forceRender: PropTypes.looseBool,
    role: PropTypes.any
  },
  data: function data() {
    return {
      _isActive: undefined
    };
  },
  render: function render() {
    this._isActive = this.forceRender || this._isActive || this.isActive;
    if (!this._isActive) {
      return null;
    }
    var _this$$props = this.$props,
      prefixCls = _this$$props.prefixCls,
      isActive = _this$$props.isActive,
      destroyInactivePanel = _this$$props.destroyInactivePanel,
      forceRender = _this$$props.forceRender,
      role = _this$$props.role;
    var contentCls = _defineProperty(_defineProperty({}, "".concat(prefixCls, "-content"), true), "".concat(prefixCls, "-content-active"), isActive);
    var child = !forceRender && !isActive && destroyInactivePanel ? null : _createVNode("div", {
      "class": "".concat(prefixCls, "-content-box")
    }, [getSlot(this)]);
    return _createVNode("div", {
      "class": contentCls,
      "role": role
    }, [child]);
  }
});