import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { defineComponent, watch } from 'vue';
import Popup from '../popup';
import { useBaseCalendar } from './calendar-base';
import CalendarProps from './calendar-props';
import Header from './calendar/header';
import ShortcutPanel from './calendar/shortcut-panel';
var Calendar = defineComponent({
  DefaultHeader: Header,
  DefaultShortcut: ShortcutPanel,
  name: 'Calendar',
  props: _objectSpread({}, CalendarProps),
  setup: function setup(props, ctx) {
    var _useBaseCalendar = useBaseCalendar(props, ctx),
      state = _useBaseCalendar.state,
      shortcutSelect = _useBaseCalendar.shortcutSelect,
      onClose = _useBaseCalendar.onClose,
      renderCalendar = _useBaseCalendar.renderCalendar;
    watch(function () {
      return props.open;
    }, function () {
      state.open = props.open;
      var defaultValue = props.defaultValue;
      if (props.open && defaultValue) {
        shortcutSelect(defaultValue[0], defaultValue[1]);
      }
    });
    return {
      onClose: onClose,
      state: state,
      renderCalendar: renderCalendar
    };
  },
  render: function render() {
    var _this = this;
    var height = document.body.clientHeight;
    var popupProps = {
      onClose: this.onClose,
      open: this.open,
      height: "".concat(height, "px"),
      width: "".concat(height, "px"),
      value: this.state.open,
      placement: this.enterDirection === 'vertical' ? 'bottom' : 'right'
    };
    return _createVNode(Popup, popupProps, {
      default: function _default() {
        return [_this.renderCalendar()];
      }
    });
  }
});
export default Calendar;