import { defineComponent, createTextVNode as _createTextVNode, createVNode as _createVNode } from 'vue';
var Header = defineComponent({
  name: 'Header',
  props: {
    title: {
      type: String
    },
    locale: {
      type: Object
    },
    showClear: {
      type: Boolean
    },
    clearIcon: {},
    prefixCls: String
  },
  render: function render() {
    var _this = this;
    var _this$$props = this.$props,
      title = _this$$props.title,
      _this$$props$locale = _this$$props.locale,
      locale = _this$$props$locale === void 0 ? {} : _this$$props$locale,
      showClear = _this$$props.showClear,
      clearIcon = _this$$props.clearIcon;
    return _createVNode("div", {
      "class": this.prefixCls + '-header'
    }, [_createVNode("span", {
      "class": this.prefixCls + '-header-left',
      "onClick": function onClick() {
        return _this.$emit('cancel');
      }
    }, [_createTextVNode("\u5173\u95ED")]), _createVNode("span", {
      "class": this.prefixCls + '-header-title'
    }, [title || locale.title]), showClear && _createVNode("span", {
      "class": this.prefixCls + '-header-right',
      "onClick": function onClick() {
        return _this.$emit('clear');
      }
    }, [clearIcon || locale.clear])]);
  }
});
export default Header;