import { createVNode as _createVNode } from "vue";
import _objectSpread from "@babel/runtime/helpers/esm/objectSpread2";
import { defineComponent, inject } from 'vue';
import PopupPicker from '../vmc-picker/popup';
export default defineComponent({
  name: 'PopupCascader',
  props: {
    cascader: {
      type: Object
    }
  },
  setup: function setup(props, _ref) {
    var emit = _ref.emit;
    var store = inject('store', undefined);
    var onCancel = function onCancel() {
      if (store.onCancel) {
        store.onCancel();
      }
      emit('cancel');
    };
    var onChange = function onChange(v) {
      emit('change', v);
    };
    var onOk = function onOk(v) {
      if (store.onOk) {
        store.onOk(v);
      }
      emit('change', v);
      emit('ok');
    };
    return {
      onCancel: onCancel,
      onOk: onOk,
      onChange: onChange
    };
  },
  render: function render() {
    var _this = this;
    var props = _objectSpread(_objectSpread(_objectSpread({
      picker: this.cascader
    }, this.$props), this.$attrs), {}, {
      onCancel: this.onCancel,
      onChange: this.onChange,
      onOk: this.onOk
    });
    return _createVNode(PopupPicker, props, {
      picker: function picker() {
        return _this.cascader;
      },
      default: this.$slots.default
    });
  }
});